VERSION = 7;
AUTO_UPDATE = True
###############################################################################
#                                               _                             #
#                                              (_)                            #
#                         _ __ ___   __ _  __ _ _  ___                        #
#                        | '_ ` _ \ / _` |/ _` | |/ __|                       #
#                        | | | | | | (_| | (_| | | (__                        #
#                        |_| |_| |_|\__,_|\__, |_|\___|                       #
#                                          __/ |                              #
#                                         |___/                               #
#                                                                             #
#             By David                                                        #
# Feel free to use. http://mouldycheerio.com/magic                            #
#   (c) 2017                                                                  #
###############################################################################

print("Loading magic module version " + str(VERSION) + "...")

import time
import sys
import urllib.request

# Slow Print
DEFAULT_SPEED = 0.1


def animatedPrint(frames, t=0.1, loops=1):
    
    sys.stdout.write(frames[0])
    sys.stdout.flush()
    last = frames[0]
    for s in range(loops):
        framenum = 1
        for a in range (0, len(frames) - 1):
            f = frames[a + 1]
            b = ""
            for i in range(len(last)):
                b = b + "\b"
            sys.stdout.write(b + frames[framenum])
            sys.stdout.flush()
            last = frames[framenum]
            time.sleep(t)
            framenum += 1
    print("")
 
    

def sPrint(string, speed=0, end="\n"):
    if speed == 0:
        speed = DEFAULT_SPEED
    for c in string:
        time.sleep(speed)
        print(c, end='')
    print(end, end='')


def p(string, speed=0):
    sPrint(string, speed)


# Asks a question
def ask(question, prompt="\n> "):
    sPrint(question, end='')
    return input(prompt)

def wait(delay=0.5):
    time.sleep(delay)


def HTTPget(url):
    txt = str(urllib.request.urlopen(url).read())
    txt = txt[2:]
    txt = txt[:-1]
    return txt

def br(size=77):
    print("=" * size)

def title(string, size=77):
    br(size)
    center(string, size)
    br(size)

def center(string, size=77):
    for l in string.split("\n"):
        sides = int((size - len(l)) / 2)
        newString = (sides * " ") + l + (sides * " ")
        print(newString)

def print_ascii(word, font="big"):
    center(mascii(word, font))

def mascii(word, font="big"):
    word = word.replace(" ", "+")

    txt = str(urllib.request.urlopen("http://artii.herokuapp.com/make?text=" + str(word) + "&font=" + font).read())
    txt = txt[2:]
    txt = txt[:-1]
    txt = txt.replace("\\\\", "\\")
    s = txt.split(str("\\n"))

    pw = ""
    for t in s:
        pw = pw + t + "\n"
    return pw

if AUTO_UPDATE:
    version = HTTPget("http://www.mouldycheerio.com/magic/magic.py").split(";")[0]
    version = version[10:]

    if int(version) > VERSION:
        print("NEW VERSION OF magic.py AVALIABLE! version: " + version)
        print("Starting download...")
        urllib.request.urlretrieve("http://www.mouldycheerio.com/magic/magic.py", "magic.py")
        print("downloaded! Please restart")

if __name__ == "__main__":
    print_ascii("magic")
    title("magic")
    ask("magic?")
    p("magic")
    animatedPrint(["magic.py           ", "agic.py           m", "gic.py           ma", "ic.py           mag", "c.py           magi", ".py           magic", "py           magic.", "y           magic.p", "           magic.py", "          magic.py ", "         magic.py  ", "        magic.py   ", "       magic.py    ", "      magic.py     ", "     magic.py      ", "    magic.py       ", "   magic.py        ", "  magic.py         ", " magic.py          "], t=0.1, loops=50)

